
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

#include "BlockHandler.h"
#include "Mixins.h"


class cBlockObserverHandler final :
	public cClearMetaOnDrop<cDisplacementYawRotator<cBlockHandler>>
{
	using Super = cClearMetaOnDrop<cDisplacementYawRotator<cBlockHandler>>;

public:

	using Super::Super;

	inline static Vector3i GetObservingFaceOffset(NIBBLETYPE a_Meta)
	{
		return -GetSignalOutputOffset(a_Meta);
	}

	inline static Vector3i GetSignalOutputOffset(NIBBLETYPE a_Meta)
	{
		switch (a_Meta & 0x7)
		{
			case 0x00: return { 0, 1, 0 };
			case 0x01: return { 0, -1, 0 };
			case 0x02: return { 0, 0, 1 };
			case 0x03: return { 0, 0, -1 };
			case 0x04: return { 1, 0, 0 };
			case 0x05: return { -1, 0, 0 };
			default:
			{
				LOGWARNING("%s: Unknown metadata: %d", __FUNCTION__, a_Meta);
				ASSERT(!"Unknown metadata while determining orientation of observer!");
				return { 0, 0, 0 };
			}
		}
	}
};
